---
title: WakeLock.request()
slug: Web/API/WakeLock/request
tags:
  - API
  - Method
  - Reference
  - Screen Wake Lock API
  - WakeLock
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("Screen Wake Lock API")}}</div>

<p class="summary">The <strong><code>request()</code></strong> method of the {{domxref("WakeLock")}} interface returns a {{jsxref("Promise")}} that resolves with a {{domxref("WakeLockSentinel")}} object, which allows control over screen dimming and locking.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>wakeLock</var> = navigator.wakeLock.request(<var>type</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><em>type</em></dt>
	<dd>Options are as follows:
	<ul>
		<li><code>'screen'</code>: Requests a screen wake lock. Prevents devices from dimming or locking the screen.</li>
	</ul>
	</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Promise")}} that resolves with a {{domxref("WakeLockSentinel")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
	<dt><code>NotAllowedError</code></dt>
	<dd>Thrown when wake lock is not available, which can happen because:
	<ul>
		<li>Document is not allowed to use screen wake lock due to screen-wake-lock policy.</li>
		<li>Document is not fully active.</li>
		<li>Document is hidden.</li>
		<li>{{Glossary("User Agent")}} could not acquire platform's wake lock.</li>
	</ul>
	</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following asynchronous function requests a {{domxref("WakeLockSentinel")}} object. The <code>request()</code> method is wrapped in a <code>try...catch</code> statement to account for if the browser refuses the request for any reason.</p>

<pre class="brush: js notranslate">const requestWakeLock = async () =&gt; {
  try {

    const wakeLock = await navigator.wakeLock.request('screen');

  } catch (err) {
    // the wake lock request fails - usually system related, such low as battery

    console.log(`${err.name}, ${err.message}`);
  }
}

requestWakeLock();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Screen Wake Lock','#the-request-method','request()')}}</td>
			<td>{{Spec2('Screen Wake Lock')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WakeLock.request")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{DOMxRef("WakeLock")}}</li>
	<li>{{DOMxRef("Navigator.wakeLock")}}</li>
</ul>
